import Big from 'big.js';
import { Unit, DisplayFormat } from './units.mjs';
export { addUnit, getUnit, setDisplay } from './units.mjs';

declare class BitcoinUnit {
    protected value: Big;
    protected unit: Unit;
    constructor(value: number, unitName: string);
    to(toUnitName: string): BitcoinUnit;
    getValue(): number;
    getValueAsString(): string;
    toString(): string;
    format(): string;
    static setDisplay(unitName: string, options: Partial<DisplayFormat>): typeof BitcoinUnit;
    static addUnit(name: string, value: number, display?: Partial<DisplayFormat>, aliases?: string[]): void;
    static getUnit(name: string): Unit;
    static setFiat(currency: string, rate: number, display?: Partial<DisplayFormat>): void;
}

export { BitcoinUnit, DisplayFormat, Unit };
