import Big from 'big.js';

type DisplayFormat = {
    format: string;
    fractionDigits: number;
    trailingZeros: boolean;
};
declare class Unit {
    name: string;
    aliases: string[];
    value: Big;
    display: DisplayFormat;
    constructor(name: string, value: number | Big, display?: Partial<DisplayFormat>, aliases?: string[]);
    setDisplay(display: DisplayFormat): void;
}
declare const getUnit: (name: string) => Unit;
declare const addUnit: (name: string, value: number, display?: Partial<DisplayFormat>, aliases?: string[]) => void;
declare const setDisplay: (unitName: string, display: Partial<DisplayFormat>) => void;

export { DisplayFormat, Unit, addUnit, getUnit, setDisplay };
